﻿; g_spot demo 01 ejn (blueznl)
;
; this program displays a simple window with a few moving buttons and a resizable
; listicongadget, press the [i] button repeatedly for updated information
;
IncludeFile("g_spot.pb")
gs_init()
;
OpenWindow(1,40,40,400,400,"g_spot",#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_ScreenCentered)
;
; visualize your window, this one will contain one listicongadget, an ok button and a cancel button
; and for good measure we'll add an 'information' button to the top
; create them in the sequence you want to tab through them
; we'll fix the positioning using rules
;
ButtonGadget(1,10,10,40,40,"[ i ]")
ListIconGadget(2,10,60,60,40,"test",100)
ButtonGadget(3,10,110,60,40,"Cancel")
ButtonGadget(4,10,160,60,40,"Ok")
;
; now create some rules
;
; let's put the information button on the right side
;
gs_rule(0,#gs_alignparentright,#gs_gadget,1,#gs_window,1,10)
;
; then we'll move the ok to the bottom right of the window
; we'll move it when we resize the window, but only to a certain limit
;
gs_rule(0,#gs_alignparentbottom,#gs_gadget,4,#gs_window,1,10,110)
gs_rule(0,#gs_alignparentright,#gs_gadget,4,#gs_window,1,10,80)
; 
; put the cancel button right next to it
;
gs_rule(0,#gs_stackleft,#gs_gadget,3,#gs_gadget,4,10)
;
; now resize the listicongadget to fill the remaining space
; 
gs_rule(0,#gs_stretchparentright,#gs_gadget,2,#gs_window,1,10,110)
gs_rule(0,#gs_stretchdown,#gs_gadget,2,#gs_gadget,4,10)
;
; and there's your beautified resizable window
; (to limit the minimal size you'd have to do some additional things)
;
Repeat
  event = WaitWindowEvent(50)
  event_gadget = EventGadget()
  ;
  Select event
  Case #PB_Event_MoveWindow, #PB_Event_SizeWindow
    gs_apply()
  Case #PB_Event_Gadget
    Select event_gadget
    Case 1
      gs_internalsviewer("")
    EndSelect
  EndSelect
Until event = #PB_Event_CloseWindow
;
gs_end()

; IDE Options = PureBasic 4.51 RC 2 (Windows - x86)
; CursorPosition = 8
; Markers = 60
; EnableAsm
; EnableUnicode
; EnableThread
; EnableXP
; Executable = demo_01.exe
; CurrentDirectory = C:\software\purebasic\_projects\
; EnableCompileCount = 1823
; EnableBuildCount = 4
; EnableExeConstant