﻿; g_spot demo 02 ejn (blueznl)
;
; this example displays a whole array of buttons, which use all sorts of rules to set
; location and size, it also creates and additional window to display the different
; rules applied, and pop's up the 'internal viewer', which in this example is
; automatically updated
;
;
IncludeFile("g_spot.pb")
gs_init()
;
Enumeration
  ;
  ; windows
  ;
  #w_main_nr
  #w_slave_nr
  ;
  ; toolbars
  ;
  #tb_main_nr
  ;
  ; gadgets
  ;
  #g_button0
  #g_button1
  #g_button2
  #g_button3
  #g_button4
  #g_button5
  #g_button6
  #g_button7
  #g_button8
  #g_button9
  #g_button10
  #g_button11
  #g_button12
  #g_button13
  #g_button14
  #g_button15
  #g_button16
  #g_button17
  #g_image
  ;
  ; images
  ;
  #i_image
  ;
EndEnumeration
;
Global event.i
Global event_gadget.i
;
gs_showhandle = #True
gs_autoshadows = #True
gs_autorefers = #True
gs_crookedrefers = #True
gs_showreferids = #True
;
gs_internalsviewer()
gs_rule(-1,#gs_setsize,#gs_gadget,gs_internalsviewer_gadgetnr,#gs_window,gs_internalsviewer_windownr)
;
OpenWindow(#w_main_nr,40,40,400,400,"gspot",#PB_Window_SystemMenu|#PB_Window_SizeGadget)
;
ButtonGadget(#g_button0,00,00,40,40,"[ i ]")
gs_rule(1,#gs_setxy,#gs_gadget,#g_button0,#gs_none,#gs_none,20,20)
;
ButtonGadget(#g_button1,10,10,40,40,"1")
ButtonGadget(#g_button2,20,20,40,40,"2")
ButtonGadget(#g_button3,30,30,10,10,"3")
ButtonGadget(#g_button4,40,40,10,10,"4")
ButtonGadget(#g_button5,50,50,10,40,"5")
ButtonGadget(#g_button6,60,60,10,40,"6")
ButtonGadget(#g_button7,70,70,40,40,"7")
ButtonGadget(#g_button8,80,80,40,40,"8")
ButtonGadget(#g_button9,90,90,40,40,"9")
ButtonGadget(#g_button10,100,100,40,40,"10")
ButtonGadget(#g_button11,110,110,40,40,"11")
ButtonGadget(#g_button12,120,120,40,40,"12")
ButtonGadget(#g_button13,130,130,40,40,"13")
ButtonGadget(#g_button14,140,140,40,40,"14")
ButtonGadget(#g_button15,150,150,40,40,"15")
ButtonGadget(#g_button16,160,160,40,40,"16")
ButtonGadget(#g_button17,160,160,40,40,"17")
;
OpenWindow(#w_slave_nr,60,60,220,220,"slave",#PB_Window_SystemMenu|#PB_Window_SizeGadget)
gs_rule(2,#gs_use,#gs_window,#w_slave_nr,#gs_window,#w_main_nr)
gs_rule(2,#gs_rightof,#gs_window,#w_slave_nr,#gs_window,#w_main_nr,20)
;
ImageGadget(#g_image,0,0,220,220,0)
CreateImage(#i_image,220,220)
gs_rule(2,#gs_setsize,#gs_gadget,#g_image,#gs_window,#w_slave_nr)
gs_rule(2,#gs_setsize,#gs_image,#i_image,#gs_window,#w_slave_nr)
;
gs_rule(1,#gs_setxy,#gs_gadget,#g_button1,#gs_gadget,#g_button0,50,0)
gs_rule(1,#gs_setx,#gs_gadget,#g_button2,#gs_gadget,#g_button1,50)
gs_rule(1,#gs_sety,#gs_gadget,#g_button2,#gs_gadget,#g_button1,0)
gs_rule(1,#gs_setxy,#gs_gadget,#g_button3,#gs_gadget,#g_button2,50,0)
gs_rule(1,#gs_setsize,#gs_gadget,#g_button3,#gs_gadget,#g_button2)
gs_rule(1,#gs_setxy,#gs_gadget,#g_button4,#gs_gadget,#g_button3,50,0)
gs_rule(1,#gs_setwidth,#gs_gadget,#g_button4,#gs_gadget,#g_button3)
gs_rule(1,#gs_setheight,#gs_gadget,#g_button4,#gs_none,#gs_none,40)
gs_rule(1,#gs_stackdown,#gs_gadget,#g_button5,#gs_gadget,#g_button0,10)
gs_rule(1,#gs_setwidth,#gs_gadget,#g_button5,#gs_window,#w_slave_nr,-40)
gs_rule(1,#gs_stackdown,#gs_gadget,#g_button6,#gs_gadget,#g_button5,10)
gs_rule(1,#gs_setheight,#gs_gadget,#g_button6,#gs_window,#w_slave_nr,-140)
gs_rule(1,#gs_setwidth,#gs_gadget,#g_button6,#gs_none,#gs_none,40)
gs_rule(1,#gs_alignparentright,#gs_gadget,#g_button7,#gs_window,#w_slave_nr,20)
gs_rule(1,#gs_alignparentbottom,#gs_gadget,#g_button7,#gs_window,#w_slave_nr,20)
gs_rule(1,#gs_stackleft,#gs_gadget,#g_button8,#gs_gadget,#g_button7,10)
gs_rule(1,#gs_stackup,#gs_gadget,#g_button9,#gs_gadget,#g_button8,10)
gs_rule(1,#gs_stackright,#gs_gadget,#g_button10,#gs_gadget,#g_button9,10)
gs_rule(1,#gs_aligntop,#gs_gadget,#g_button11,#gs_gadget,#g_button10)
gs_rule(1,#gs_rightof,#gs_gadget,#g_button11,#gs_gadget,#g_button6,10)
gs_rule(1,#gs_stretchright,#gs_gadget,#g_button11,#gs_gadget,#g_button9,10,40)
gs_rule(1,#gs_use,#gs_gadget,#g_button12,#gs_gadget,#g_button11,0,50)
gs_rule(1,#gs_alignright,#gs_gadget,#g_button13,#gs_gadget,#g_button11,0,50)
gs_rule(1,#gs_alignbottom,#gs_gadget,#g_button13,#gs_gadget,#g_button5,50)
gs_rule(1,#gs_alignleft,#gs_gadget,#g_button14,#gs_gadget,#g_button13,50)
gs_rule(1,#gs_alignright,#gs_gadget,#g_button15,#gs_gadget,#g_button13,0)
gs_rule(1,#gs_below,#gs_gadget,#g_button15,#gs_gadget,#g_button13,10)
gs_rule(1,#gs_above,#gs_gadget,#g_button14,#gs_gadget,#g_button15,10)
gs_rule(1,#gs_leftof,#gs_gadget,#g_button16,#gs_gadget,#g_button15,10)
gs_rule(1,#gs_stretchleft,#gs_gadget,#g_button16,#gs_gadget,#g_button6,10,40)
gs_rule(1,#gs_stretchup,#gs_gadget,#g_button16,#gs_gadget,#g_button5,10,40)
gs_rule(1,#gs_stretchdown,#gs_gadget,#g_button16,#gs_gadget,#g_button11,10)
gs_rule(1,#gs_stretchright,#gs_gadget,#g_button4,#gs_gadget,#g_button10,-40)
gs_rule(1,#gs_stackup,#gs_gadget,#g_button17,#gs_gadget,#g_button9,10)
gs_rule(1,#gs_stretchparentright,#gs_gadget,#g_button17,#gs_window,#w_slave_nr,20,40)
gs_rule(1,#gs_stretchup,#gs_gadget,#g_button17,#gs_gadget,#g_button14,10,40)
;
;
Repeat
  ;
  event = WaitWindowEvent(50)
  event_gadget = EventGadget()
  ;
  Select event
  Case #PB_Event_MoveWindow, #PB_Event_SizeWindow
    If gs_apply(-1)
      StartDrawing(ImageOutput(#i_image))
        DrawingMode(#PB_2DDrawing_Outlined)
        gs_drawallelements(1)
        gs_internalsviewer()
      StopDrawing()
      SetGadgetState(#g_image,ImageID(#i_image))
    EndIf
  Case #PB_Event_Gadget
    Select event_gadget
    Case #g_button0
      gs_internalsviewer("")
    EndSelect
  EndSelect
  ;
Until event = #PB_Event_CloseWindow
;
gs_end()

; IDE Options = PureBasic 4.51 RC 2 (Windows - x86)
; CursorPosition = 4
; Markers = 157
; EnableAsm
; EnableUnicode
; EnableThread
; EnableXP
; Executable = g_spot.exe
; CurrentDirectory = C:\software\purebasic\_projects\
; EnableCompileCount = 1838
; EnableBuildCount = 2
; EnableExeConstant